/* asm linkage for x86 */

#include "mapper.h"
#include "consts.h"

.globl START
START:
  xor %esi,%esi
  mov $VBL,%ebx
  mov %esi,CLOCK
  sub %ebx,%esi
  mov $_CODE_BASE,%ebx
  mov %esi,_CTNI
  xor %eax,%eax
  xor %ecx,%ecx
  xor %edx,%edx
  xor %ebp,%ebp
  xor %edi,%edi
  jmp %ebx

.globl U
U:

/* This will trace all branches for debugging */
/*  mov %ebx,_PCR /* */
/*  mov -4(%esp),%ebx /* */
/*  mov %ebx,_DMOD /* */
/*  mov _PCR,%ebx /* */
/*  pusha /* */
/*  call trace /* */
/*  popa /* */
/*  mov _DMOD,%ebx /* */
/*  mov %ebx,-4(%esp) /* */
/*  mov _PCR,%ebx /* */

  test %esi,%esi
  jns NMI
  mov %ebx,_PCR
  mov -4(%esp),%ebx
  mov %ebx,_DMOD
  mov _PCR,%ebx
  cmp $0x7fff,%ebx
  jle selfmod
recompile:
  push %eax
  mov %ebx,%eax
  shr $12,%eax
  sub $_RAM,%ebx
  mov _MAPTABLE(,%eax,4),%eax
  add %ebx,%eax
  mov _INT_MAP(,%eax,4),%ebx
  pop %eax
  test %ebx,%ebx
  jne 0f
recompile_always:
  pusha
  mov _PCR,%ebx
  push %ebx
  call translate
  pop %ebx
  popa
  mov _XPC,%ebx
0:
  push %ecx
  cmp $0,dolink
  jz 1f  /* to disable linking (for debugging) */
  mov _PCR,%ecx
  and $0xFFFFF000,%ecx
  cmp %ecx,_LASTBANK
  mov %ecx,_LASTBANK
  jne 1f /* don't link across memory banks - mapper might change! */
  cmp $0x7fff,%ecx
  jle 1f /* don't link to RAM code */
  mov _DMOD,%ecx
  test %ecx,%ecx
  jz 1f  /* skip null address */
  push %eax
  mov %ebx,%eax
  sub %ecx,%eax
  sub $4,%eax
  mov %eax,(%ecx)
  pop %eax
1:
  pop %ecx
  jmp *%ebx


.globl NMI
NMI:
 pusha
 mov $7,%esi
 sub _CTNI,%esi
 add CLOCK,%esi
 sub $CPF,%esi
 sbb %ecx,%ecx
 and $CPF,%ecx
 add %ecx,%esi
 mov %esi,CLOCK
 movl irqflag,%eax
 testl %eax,%eax
 jnz irq
 call donmi
 testl %eax,%eax
 jz skipint
/* do the actual NMI code */
 popa
 pusha
/* push return address */
 decl   %ebx
 movl   _STACKPTR,%eax
 movb   %bh,(%eax)
 decl   %eax
 orl    $0x100,%eax
 movb   %bl,(%eax)
 decb   %al
/* php */
 andl   $0x34,_FLAGS
 xorl   %ebx,%ebx
 add    $0xffffffff,%ebp
 mov    _FLAGS,%ebp
 adc    $0,%ebp
 testl  $0xff,%edi
 setz   %bl
 shll   %ebx
 orl    %ebx,%ebp
 movl   %edi,%ebx
 shrl   %ebx
 andl   $0x80,%ebx
 orl    %ebx,%ebp
 movl   _VFLAG,%ebx
 addl   $0x80,%ebx
 addl   $0xffffff00,%ebx
 sbbl   %ebx,%ebx
 andl   $0x40,%ebx
 orl    %ebp,%ebx
 movb   %bl,(%eax)
 decb   %al
 mov    %al,_STACKPTR
 popa
 movl   $0,-4(%esp)
 movl   _CTNI,%esi
 movl   _MAPTABLE+60,%ebx
 andl   $0x24,_FLAGS
 orl    $0x04,_FLAGS
 movzwl 0xFFFA(%ebx),%ebx
 jmp U
2:    /* don't do NMI */
skipint:
 popa
 movl $0,-4(%esp)
 mov _CTNI,%esi
 jmp U

irq:
 movl CLOCK,%eax
 subl $VBL,%eax
 movl %eax,_CTNI
/* Check interrupt-disable flag */
 movl _FLAGS,%eax
 movl $0,irqflag
 testl $0x04,%eax
 jnz skipint
/* no interrupts while the screen is off -
/* Well, actually we should delay the countdown while scanlines aren't */
/* being drawn, instead of just dropping the interrupt as we do now. */
/* This is really only here to stop games from crashing due to unhandled */
/* interrupts. */
 movl _REG1+1,%eax
 testl $0x08,%eax
 jz skipint
/* do IRQ */
 popa
 pusha
/* push return address */
 decl   %ebx
 movl   _STACKPTR,%eax
 movb   %bh,(%eax)
 decl   %eax
 orl    $0x100,%eax
 movb   %bl,(%eax)
 decb   %al
/* php */
 andl   $0x34,_FLAGS
 xorl   %ebx,%ebx
 add    $0xffffffff,%ebp
 mov    _FLAGS,%ebp
 adc    $0,%ebp
 testl  $0xff,%edi
 setz   %bl
 shll   %ebx
 orl    %ebx,%ebp
 movl   %edi,%ebx
 shrl   %ebx
 andl   $0x80,%ebx
 orl    %ebx,%ebp
 movl   _VFLAG,%ebx
 addl   $0x80,%ebx
 addl   $0xffffff00,%ebx
 sbbl   %ebx,%ebx
 andl   $0x40,%ebx
 orl    %ebp,%ebx
 movb   %bl,(%eax)
 decb   %al
 mov    %al,_STACKPTR
 popa
 movl   $0,-4(%esp)
 movl   _CTNI,%esi
 movl   _MAPTABLE+60,%ebx
 andl   $0x24,_FLAGS
 orl    $0x04,_FLAGS
 movzwl 0xFFFE(%ebx),%ebx
 jmp U

.globl INPUT
INPUT:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %ebx
  call input
  pop %ebx
  popa
  movl _CTNI,%esi
  movsbl _INRET,%edi
  ret

.globl OUTPUT
OUTPUT:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call output
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret


/* Mapper Linkage */

.globl MAPPER_NONE
MAPPER_NONE:
  ret

.globl MAPPER_MMC1
MAPPER_MMC1:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call mmc1
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret

.globl MAPPER_UNROM
MAPPER_UNROM:
  pusha
  push %eax
  push %ebx
  call unrom
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_CHROM
MAPPER_CHROM:
  pusha
  push %eax
  push %ebx
  call crom
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_MMC3
MAPPER_MMC3:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call mmc3
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret

.globl MAPPER_MMC2
MAPPER_MMC2:
  pusha
  push %eax
  push %ebx
  call mmc2
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_CLRDRMS
MAPPER_CLRDRMS:
  pusha
  push %eax
  push %ebx
  call clrdrms
  pop %ebx
  pop %eax
  popa
  ret

/* This is an interpreter to handle self-modifying code. */
/* This is far from complete, but the most common cases are handled. */

selfmod:
  cmpb $0x4c,_RAM(%ebx)
  je ijmp
  cmpb $0xad,_RAM(%ebx)
  je ilda
  cmpb $0x20,_RAM(%ebx)
  je ijsr
  cmpb $0x6c,_RAM(%ebx)
  je ijmpind
  jmp recompile

ijmp:
 movzwl _RAM+1(%ebx),%ebx
 add $3,%esi
 movl   $0,-4(%esp)
 jmp U

ijmpind:
 movzwl _RAM+1(%ebx),%ebx
 pushl %eax
 movl  %ebx,%eax
 shrl  $0xc,%ebx
 movl  _MAPTABLE(,%ebx,4),%ebx
 addl  $5,%esi
 movzwl  (%ebx,%eax,1),%ebx
 popl  %eax
 movl  $0,-4(%esp)
 jmp U

ilda:
 movzwl _RAM+1(%ebx),%eax
 movl  %eax,%edi
 shrl   $0xc,%eax
 movl   _MAPTABLE(,%eax,4),%eax
 movsbl (%edi,%eax,1),%eax
 movl   %eax,%edi
 add $4,%esi
 add $3,%ebx
 jmp U

ijsr:
 pushl  %eax
 mov    _STACKPTR,%eax
 add    $2,%ebx
 mov    %bh,(%eax)
 decl   %eax
 orl    $0x100,%eax
 movb   %bl,(%eax)
 decb   %al
 addl   $6,%esi
 movb   %al,_STACKPTR
 popl   %eax
 movzwl _RAM-1(%ebx),%ebx
 movl   $0,-4(%esp)
 jmp U
